#ifndef __DRIVER_ENTRY_H__
#define __DRIVER_ENTRY_H__

extern "C"
{
	#include <ntddk.h>
	#include <tdikrnl.h>
}

#include "define.h"
#include "ioctl_mSendUdp.h"
#include "debug_macros.h"

extern "C"
{
	//entry point
	NTSTATUS DriverEntry(PDRIVER_OBJECT pDriverObject, PUNICODE_STRING pRegistryPath);

	//initialize
	NTSTATUS createDevice(PDRIVER_OBJECT pDriverObject);

	//finalize
	VOID unloadDevice(PDRIVER_OBJECT pDriverObject);

	//IRP handler
	NTSTATUS dispatchDefault_NotImplemented(PDEVICE_OBJECT pDeviceObject, PIRP pIrp);
	NTSTATUS dispatchDefault_Success(PDEVICE_OBJECT pDeviceObject, PIRP pIrp);
	NTSTATUS dispatchDeviceControl(PDEVICE_OBJECT pDeviceObject, PIRP pIrp);

	//functions
	VOID worker(PDEVICE_OBJECT pDeviceObject, PVOID pContext);
	NTSTATUS sendDatagram(PFILE_OBJECT pFileTransportAddress, ULONG addressRemote, USHORT portRemote, PMDL pMdl, PULONG pLengthProcessed);
	NTSTATUS openTransportAddressUdp(PHANDLE phTransportAddress, PFILE_OBJECT *ppFileTransportAddress);
	NTSTATUS closeTransportAddressUdp(HANDLE hTransportAddress, PFILE_OBJECT pFileTransportAddress);
}

#endif
//MmGetMdlByteCount